/*
 * $Id: split_pdf.java,v 1.1 2003/05/02 13:01:29 blowagie Exp $
 * $Name:  $
 *
 * This code is free software. It may only be copied or modified
 * if you include the following copyright notice:
 *
 * This class by Bruno Lowagie. Copyright (c) 2002 Bruno Lowagie.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * itext@lowagie.com
 */

/**
 * This class demonstrates how to splot a PDF file using iText.
 * @author Bruno Lowagie
 */
/*package com.lowagie.tools;*/

import java.io.*;
import java.util.*;
import java.text.*;

import com.lowagie.text.*;
import com.lowagie.text.pdf.*;

public class pdfpg extends java.lang.Object {

	public static String[] split(String source, String delim) 
	{
		String[] wordLists;
		if (source == null) 
		{
			wordLists = new String[1];
			wordLists[0] = source;
			return wordLists;
		}
		if (delim == null) 
		{
			delim = ",";
		}
		StringTokenizer st = new StringTokenizer(source, delim);
		int total = st.countTokens();
		wordLists = new String[total];
		for (int i = 0; i < total; i++) 
		{
			wordLists[i] = st.nextToken();
		}
		return wordLists;
	}
	
	public static String[] ParseString(String m_szInput, int max)
	{
		String[] wordLists;
		wordLists = split(m_szInput, ",");
		if(max == 0)
			return wordLists;
		Vector wordLists2 = new Vector();
		wordLists2.add(wordLists[0]);
		for(int i = 1; i < wordLists.length; i++)
		{
			int pos = wordLists[i].indexOf('-');
			if(pos != -1)
			{//1-3,13-1,-10,10-
				if(pos == 0)
				{//-10
					String m_strEndPage = new String(wordLists[i].toCharArray(),1,wordLists[i].length()-1);
					int endpage = Integer.valueOf(m_strEndPage).intValue();
					for(int j = 1; j <= endpage; j++)
					{
						Integer temp = new Integer(j);
						wordLists2.add(temp.toString());
					}
				}
				else if(pos == wordLists[i].length()-1)
				{//10-
					String m_strFirstPage = new String(wordLists[i].toCharArray(),0,wordLists[i].length()-1);
					int firstpage = Integer.valueOf(m_strFirstPage).intValue();
					for(int j = firstpage; j <= max; j++)
					{
						Integer temp = new Integer(j);
						wordLists2.add(temp.toString());
					}
				}
				else
				{
					String[] wordLists3;
					wordLists3 = split(wordLists[i], "-");
					if(wordLists3.length == 2)
					{//1-10,10-1
						int firstpage = Integer.valueOf(wordLists3[0]).intValue();
						int endpage = Integer.valueOf(wordLists3[1]).intValue();
						if(firstpage < endpage)
							for(int j = firstpage; j <= endpage; j++)
							{
								Integer temp = new Integer(j);
								wordLists2.add(temp.toString());
							}
						else
							for(int j = firstpage; j >= endpage; j--)
							{
								Integer temp = new Integer(j);
								wordLists2.add(temp.toString());
							}
					}
				}
			}
			else
			{//1,3,6,9
				wordLists2.add(wordLists[i]);
			}
		}
		//for(int i = 1; i < wordLists2.size(); i++)
		//{
		//	System.out.println("***pages = " + wordLists2.elementAt(i));
		//}

		wordLists = new String[wordLists2.size()];
		wordLists2.copyInto(wordLists);
		return wordLists;
	}
    
	public static void mergepdf(String args[]) 
	{
		try {
			int f = 0;
			String outFile = args[args.length-1];
			Document document = null;
			PdfCopy  writer = null;
			while (f < args.length-1) 
			{
				String[] wordLists = ParseString(args[f],0);
				String m_strInputPDF = wordLists[0];
				// we create a reader for a certain document
				PdfReader reader = new PdfReader(m_strInputPDF);
				reader.consolidateNamedDestinations();
				// we retrieve the total number of pages
				int n = reader.getNumberOfPages();
				System.out.println("There are " + n + " pages in " + m_strInputPDF);
				wordLists = ParseString(args[f],n);
				
				if (f == 0)
				{
					// step 1: creation of a document-object
					document = new Document(reader.getPageSizeWithRotation(1));
					// step 2: we create a writer that listens to the document
					writer = new PdfCopy(document, new FileOutputStream(outFile));
					// step 3: we open the document
					document.open();
				}
				// step 4: we add content
				PdfImportedPage page;
				if(wordLists.length == 1)
				{//Convert all pages
					for (int i = 1; i <= n; i++)
					{
						page = writer.getImportedPage(reader, i);
						writer.addPage(page);
						System.out.println("Processed page " + i);
					}
				}
				else
				{//Specify pages
					for (int i = 1; i < wordLists.length; i++)
					{
						int pageindex = Integer.valueOf(wordLists[i]).intValue();
						if(pageindex >= 1 && pageindex <= n)
						{
							page = writer.getImportedPage(reader, pageindex);
							writer.addPage(page);
							System.out.println("Processed page " + pageindex);
						}
					}
				}
				PRAcroForm form = reader.getAcroForm();
				if (form != null)
					writer.copyAcroForm(reader);
				f++;
			}
			// step 5: we close the document
			document.close();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	public static void splitpdf(String args[]) 
	{
		try {
			int f = 1;
			Document document = null;
			PdfCopy  writer = null;
			while (f < args.length-1)
			{
				String m_strInputPDF = args[f];
				// we create a reader for a certain document
				PdfReader reader = new PdfReader(m_strInputPDF);
				reader.consolidateNamedDestinations();
				// we retrieve the total number of pages
				int n = reader.getNumberOfPages();
				System.out.println("There are " + n + " pages in " + m_strInputPDF);
		
				for (int i = 1; i <= n; i++)
				{
					String outFile = args[args.length-1];
					
					DecimalFormat formatter = new DecimalFormat("0000");
					formatter.setMinimumIntegerDigits(4);
					String m_format = formatter.format(i);

					outFile += m_format;
					outFile += ".pdf";
					// step 1: creation of a document-object
					document = new Document(reader.getPageSizeWithRotation(1));
					// step 2: we create a writer that listens to the document
					writer = new PdfCopy(document, new FileOutputStream(outFile));
					// step 3: we open the document
					document.open();

					// step 4: we add content
					PdfImportedPage page;
					page = writer.getImportedPage(reader, i);
					writer.addPage(page);

					PRAcroForm form = reader.getAcroForm();
					if (form != null)
						writer.copyAcroForm(reader);

					// step 5: we close the document
					document.close();
					System.out.println("Processed page " + i);
				}
				f++;
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	public static void main(String args[]) 
	{
		if (args.length < 2) 
		{
			System.err.println("PDF Split/Merge software v1.0");
			System.err.println("Copyright @2003-2004 www.verypdf.com Inc");
			System.err.println("arguments: file1 [file2 ...] destfile");
			System.err.println("arguments: burst C:\\input.pdf C:\\output");
			System.err.println("Example:");
			System.err.println("     C:\\A.pdf,1,3 C:\\merged.pdf");
			System.err.println("     C:\\A.pdf,-20,50 C:\\merged.pdf");
			System.err.println("     C:\\A.pdf,1,3- C:\\merged.pdf");
			System.err.println("     C:\\A.pdf,1,2,3 C:\\B.pdf,5,2,9 C:\\merged.pdf");
			System.err.println("     C:\\A.pdf,1,1-9 C:\\B.pdf,5,2,9 C:\\A.pdf,10 C:\\merged.pdf");
			System.err.println("     burst C:\\A.pdf C:\\split");
			return;
		}
		if(args[0].equals("burst"))
			splitpdf(args);
		else
			mergepdf(args);
	}
}