//////////////////////////////////////////////////////////////
//
//  Description	: PDF Split-Merge software
//  Author	: verypdf.com Inc
//  Version	: Ver 1.1
//  Platform	: Windows95/98/Me/NT/2000/XP
//  Environment	: Visual C++ 6.0
//  Date	: 2004/01/01
//
//  Copyright(C) 2003--2004 verypdf.com Inc
//      
//  Contact infomation:
//        http://www.verypdf.com/
//        support@verypdf.com
//
//  This program is shareware; you can redistribute and/or 
//  modify it under the terms of the GNU General Public License.
//  See the GNU General Public License for more details.
//
//         Portion base on iText Java Library
//            http://www.lowagie.com/iText/
//////////////////////////////////////////////////////////////
// PDFMerge.cpp : implementation file
//

#include "stdafx.h"
#include "pdfpage.h"
#include "PDFMerge.h"
#include "About.h"
#include "Redirect.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPDFMerge property page

IMPLEMENT_DYNCREATE(CPDFMerge, CPropertyPage)

CPDFMerge::CPDFMerge() : CPropertyPage(CPDFMerge::IDD)
{
	//{{AFX_DATA_INIT(CPDFMerge)
	m_strOutputPDF = _T("");
	//}}AFX_DATA_INIT
}

CPDFMerge::~CPDFMerge()
{
}

void CPDFMerge::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPDFMerge)
	DDX_Control(pDX, IDC_EDIT_OUTPUT1, m_ctrlLogOutput);
	DDX_Control(pDX, IDC_LIST_FILES, m_ctrlFileList);
	DDX_Text(pDX, IDC_EDIT_OUTPUTDIR, m_strOutputPDF);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPDFMerge, CPropertyPage)
	//{{AFX_MSG_MAP(CPDFMerge)
	ON_WM_DESTROY()
	ON_BN_CLICKED(ID_ADD, OnAdd)
	ON_BN_CLICKED(ID_REMOVE, OnRemove)
	ON_BN_CLICKED(ID_UP, OnUp)
	ON_BN_CLICKED(ID_DOWN, OnDown)
	ON_BN_CLICKED(ID_VIEW, OnView)
	ON_BN_CLICKED(IDC_BUTTON_BROWER_DIR, OnButtonBrowerDir)
	ON_BN_CLICKED(IDC_BUTTON_VIEW2, OnButtonView2)
	ON_BN_CLICKED(ID_RUN, OnRun)
	ON_BN_CLICKED(ID_ABOUT, OnAbout)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_FILES, OnDblclkListFiles)
	ON_BN_CLICKED(ID_REGISTER, OnRegister)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPDFMerge message handlers
static int _gnColSize[] =
{
	200,
	150,
};
static CString _gcsColLabel[] =
{
	_T("Filename"),
	_T("Pages"),
};
BOOL CPDFMerge::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_ctrlFileList.SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE,0,
		LVS_EX_FULLROWSELECT|LVS_EX_HEADERDRAGDROP|LVS_EX_FLATSB|LVS_EX_GRIDLINES);
	m_ctrlFileList.ModifyStyle(0, LVS_SHOWSELALWAYS|LVS_REPORT);

	SHFILEINFO	    sfi;
	ghsmallimage = (HIMAGELIST)SHGetFileInfo((LPCSTR)"C:\\", 0,&sfi,sizeof(SHFILEINFO), SHGFI_SYSICONINDEX | SHGFI_SMALLICON);
	ghlargeimage = (HIMAGELIST)SHGetFileInfo((LPCSTR)"C:\\", 0,&sfi,sizeof(SHFILEINFO), SHGFI_SYSICONINDEX | SHGFI_LARGEICON);

	m_ImageList.Attach(ghsmallimage);
	m_ImageListNormal.Attach(ghlargeimage);

	m_ctrlFileList.SetImageList (&m_ImageList, LVSIL_SMALL);
	m_ctrlFileList.SetImageList (&m_ImageListNormal, LVSIL_NORMAL);

	LV_COLUMN lvCol;
	lvCol.mask = LVCF_FMT|LVCF_WIDTH|LVCF_TEXT|LVCF_SUBITEM;
	for (int i = 0; i < sizeof(_gnColSize)/sizeof(int); ++i)
	{
		lvCol.iSubItem = i;
		lvCol.pszText = (char*)(LPCTSTR)_gcsColLabel[i];
		lvCol.cx = _gnColSize[i];
		lvCol.fmt = LVCFMT_LEFT;
		m_ctrlFileList.InsertColumn(i, &lvCol);
	}

	m_strOutputPDF = AfxGetApp()->GetProfileString("CPDFSplit","m_strOutputPDF");
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPDFMerge::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData();
	AfxGetApp()->WriteProfileString("CPDFSplit","m_strOutputPDF",m_strOutputPDF);
}

void CPDFMerge::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CPropertyPage::OnCancel();
}

void CPDFMerge::OnDestroy() 
{
	m_ctrlFileList.SetImageList (NULL, LVSIL_SMALL);
	m_ctrlFileList.SetImageList (NULL, LVSIL_NORMAL);
	m_ImageList.Detach();
	m_ImageListNormal.Detach();

	CPropertyPage::OnDestroy();
}
VOID	GetFileName(HWND hWnd,vector<string>& m_szPDFFileAry)
{
	char path_buffer[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_PATH];
	char ext[_MAX_EXT];

	OPENFILENAME ofn;
	//file type filters
	static char BASED_CODE szFilterSpec[] = 
	  	  "PDF File(*.PDF)\0*.PDF\0\0";

	CHAR szFileTitle[MAX_PATH];
	
	strcpy(szFileTitle, "");

	CString strInitialDir = AfxGetApp()->GetProfileString("Paramter","strInitialDir");

	
	char *m_pChBuf = NULL;
	if ( ( m_pChBuf	= ( char * ) malloc( 1024*100 )) == NULL )
		return;
	memset(m_pChBuf,0,1024*100);
	//fill in non-variant fields of OPENFILENAME struct.
	ofn.lStructSize		= sizeof(OPENFILENAME);
	ofn.hwndOwner		= hWnd;
	ofn.hInstance		= ::AfxGetInstanceHandle();
	ofn.lpstrFilter		= szFilterSpec;
	ofn.lpstrCustomFilter	= NULL;
	ofn.nMaxCustFilter	= 0;
	ofn.nFilterIndex	= 0;
	ofn.lpstrFile		= m_pChBuf;
	ofn.nMaxFile		= 20000;
	ofn.lpstrInitialDir	= strInitialDir;
	ofn.lpstrFileTitle	= szFileTitle;
	ofn.nMaxFileTitle	= MAX_PATH;
	ofn.lpstrTitle		= "PDF Merge";
	ofn.lpstrDefExt		= "PDF";
	ofn.Flags		= OFN_FILEMUSTEXIST | OFN_HIDEREADONLY|OFN_ALLOWMULTISELECT|OFN_EXPLORER;

	//Use standard open dialog
	if (!GetOpenFileName ((LPOPENFILENAME)&ofn))
	{
	}
	else
	{
		char* pChBuf = m_pChBuf;
		pChBuf += strlen( pChBuf ) + 1;
		if ( *pChBuf == 0 )		//only one file
		{
			_splitpath(m_pChBuf, drive, dir, fname, ext );
			_makepath(path_buffer,drive, dir,"","");
			AfxGetApp()->WriteProfileString("Paramter","strInitialDir",path_buffer);
			m_szPDFFileAry.push_back(m_pChBuf);
		}
		else
		{//multiple files
			while(*pChBuf)
			{
				strcpy(path_buffer,m_pChBuf);
				if(path_buffer[strlen(path_buffer)-1] != '\\')
					strcat(path_buffer,"\\");
				strcat(path_buffer,pChBuf);
				m_szPDFFileAry.push_back(path_buffer);
				pChBuf += strlen( pChBuf ) + 1;
			}
			AfxGetApp()->WriteProfileString("Paramter","strInitialDir",m_pChBuf);
		}
	}
	free(m_pChBuf);
	return;
}

void CPDFMerge::OnAdd() 
{
	vector<string>	m_szPDFFileAry;
	GetFileName(m_hWnd,m_szPDFFileAry);
	AddFilesIntoFileList(m_szPDFFileAry);
}

void CPDFMerge::OnRemove() 
{
	int nItem;
	do{
		nItem = -1;
		nItem = m_ctrlFileList.GetNextItem(nItem, LVNI_SELECTED);
		if(nItem == -1)
			break;
		m_ctrlFileList.DeleteItem(nItem);
	}while(nItem != -1);
}

void CPDFMerge::OnUp() 
{
	int m_iItemCount = m_ctrlFileList.GetItemCount();
	if(m_iItemCount <= 1)
		return;
	UINT uSelectedCount = m_ctrlFileList.GetSelectedCount();
	if (uSelectedCount < 1)
		return;
	int nItem = m_ctrlFileList.GetNextItem(-1, LVNI_SELECTED);
	if(nItem == -1)
		return;
	if(nItem == 0)//first item
		return;
	CString m_strFileName = m_ctrlFileList.GetItemText(nItem,0);
	CString m_strPages = m_ctrlFileList.GetItemText(nItem,1);

	CString m_strFileName1 = m_ctrlFileList.GetItemText(nItem-1,0);
	CString m_strPages1 = m_ctrlFileList.GetItemText(nItem-1,1);
	
	m_ctrlFileList.SetItemText(nItem,0,m_strFileName1);
	m_ctrlFileList.SetItemText(nItem,1,m_strPages1);

	m_ctrlFileList.SetItemText(nItem-1,0,m_strFileName);
	m_ctrlFileList.SetItemText(nItem-1,1,m_strPages);

	CRect rect;
	if(m_ctrlFileList.GetItemRect(nItem-1,&rect,LVIR_LABEL))
		m_ctrlFileList.SendMessage(WM_LBUTTONDOWN,0,MAKELPARAM(rect.left,rect.top));
}

void CPDFMerge::OnDown() 
{
	int m_iItemCount = m_ctrlFileList.GetItemCount();
	if(m_iItemCount <= 1)
		return;
	UINT uSelectedCount = m_ctrlFileList.GetSelectedCount();
	if (uSelectedCount < 1)
		return;
	int nItem = m_ctrlFileList.GetNextItem(-1, LVNI_SELECTED);
	if(nItem == -1)
		return;
	if(nItem == m_iItemCount-1)//last item
		return;
	CString m_strFileName = m_ctrlFileList.GetItemText(nItem,0);
	CString m_strPages = m_ctrlFileList.GetItemText(nItem,1);

	CString m_strFileName1 = m_ctrlFileList.GetItemText(nItem+1,0);
	CString m_strPages1 = m_ctrlFileList.GetItemText(nItem+1,1);
	
	m_ctrlFileList.SetItemText(nItem,0,m_strFileName1);
	m_ctrlFileList.SetItemText(nItem,1,m_strPages1);

	m_ctrlFileList.SetItemText(nItem+1,0,m_strFileName);
	m_ctrlFileList.SetItemText(nItem+1,1,m_strPages);

	CRect rect;
	if(m_ctrlFileList.GetItemRect(nItem+1,&rect,LVIR_LABEL))
		m_ctrlFileList.SendMessage(WM_LBUTTONDOWN,0,MAKELPARAM(rect.left,rect.top));
}

void CPDFMerge::OnView() 
{
	UINT uSelectedCount = m_ctrlFileList.GetSelectedCount();
	if (uSelectedCount < 1)
		return;

	POSITION pos = m_ctrlFileList.GetFirstSelectedItemPosition();
	while (pos)
	{
		int nItem = m_ctrlFileList.GetNextSelectedItem(pos);
		CString m_strFileName = m_ctrlFileList.GetItemText(nItem,0);
		ShellExecute(m_hWnd,"open",m_strFileName,NULL,NULL,SW_SHOW);
	}
}

void CPDFMerge::OnButtonBrowerDir() 
{
	char *szTitle = "Select PDF File";
	char *sFilter = "PDF Files (*.PDF)|*.PDF||";
	CFileDialog m_dlgFile(FALSE,szTitle,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,sFilter,NULL);
	if(m_dlgFile.DoModal() == IDOK)
	{
		UpdateData();
		m_strOutputPDF = m_dlgFile.GetPathName();
		UpdateData(FALSE);
	}	
}

void CPDFMerge::OnButtonView2() 
{
	UpdateData();
	if(m_strOutputPDF.GetLength() > 0)
		ShellExecute(m_hWnd,"open",m_strOutputPDF,NULL,NULL,SW_SHOWNORMAL);	
}
extern void GetModulePath(char *out_path,char *in_name);
void CPDFMerge::OnRun() 
{
	UpdateData();
	int m_iItemCount = m_ctrlFileList.GetItemCount();
	if(m_iItemCount <= 1)
		return;
	if(m_strOutputPDF.GetLength() == 0)
		return;
	char commandline[1024];
	GetModulePath(commandline,"pdfpg.exe");

	CString m_strCommandLine;
	m_strCommandLine = commandline;
	m_strCommandLine += " ";

	for(int i = 0; i < m_iItemCount; i++)
	{
		CString m_strFileName = m_ctrlFileList.GetItemText(i,0);
		CString m_strPages = m_ctrlFileList.GetItemText(i,1);
		m_strCommandLine += "\"";
		m_strCommandLine += m_strFileName;
		if(m_strPages.GetLength() > 0)
		{
			m_strCommandLine += ",";
			m_strCommandLine += m_strPages;
		}
		m_strCommandLine += "\" ";
	}
	m_strCommandLine += "\"";
	m_strCommandLine += m_strOutputPDF;
	m_strCommandLine += "\"";

	CRedirect	*m_pRedirect;
	m_pRedirect = new CRedirect((LPTSTR)((LPCTSTR)m_strCommandLine),  &m_ctrlLogOutput);
	SetItemsStatus(FALSE);
	m_pRedirect->Run();
	delete m_pRedirect;
	m_pRedirect = 0;
	SetItemsStatus(TRUE);
}
void CPDFMerge::SetItemsStatus(BOOL m_bEnable)
{
	if(!m_bEnable)
		BeginWaitCursor();
	else
		EndWaitCursor();
	EnableWindow(m_bEnable);
	GetDlgItem(IDC_STATIC0)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_STATIC1)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_LIST_FILES)->EnableWindow(m_bEnable);
	GetDlgItem(ID_ADD)->EnableWindow(m_bEnable);
	GetDlgItem(ID_REMOVE)->EnableWindow(m_bEnable);
	GetDlgItem(ID_UP)->EnableWindow(m_bEnable);
	GetDlgItem(ID_DOWN)->EnableWindow(m_bEnable);
	GetDlgItem(ID_VIEW)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_EDIT_OUTPUTDIR)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_BUTTON_BROWER_DIR)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_BUTTON_VIEW2)->EnableWindow(m_bEnable);
	GetDlgItem(ID_RUN)->EnableWindow(m_bEnable);
	GetDlgItem(ID_ABOUT)->EnableWindow(m_bEnable);
}
void CPDFMerge::OnAbout() 
{
	CAbout m_dlgAbout;
	m_dlgAbout.DoModal();
}
void CPDFMerge::AddFilesIntoFileList(vector<string>& m_szPDFFileAry)
{
	int nsize = m_szPDFFileAry.size();
	if(nsize == 0)
		return;
	for(int i = 0; i < nsize; i++)
	{
		int	nI = m_ctrlFileList.GetItemCount();
		const char* ptrFileName = m_szPDFFileAry[i].c_str();

		SHFILEINFO	sfi;
		SHGetFileInfo(ptrFileName,0,&sfi,sizeof(SHFILEINFO),SHGFI_SYSICONINDEX | SHGFI_SMALLICON |
					  SHGFI_ATTRIBUTES | SHGFI_TYPENAME);

		//Filename
		AddItem(ptrFileName,nI,0,-1,sfi.iIcon,-1);

		m_ctrlFileList.EnsureVisible(nI,TRUE);
	}
}
int CPDFMerge::AddItem(LPCTSTR strItem, int nItem, int nSubItem, UINT nState, int nImageIndex, long nParam)
{
	LVITEM lvItem;
	lvItem.mask	= LVIF_TEXT;
	lvItem.iItem	= nItem;
	lvItem.iSubItem = nSubItem;
	lvItem.pszText	= (LPTSTR)strItem;

	if (nState != -1)
	{
		lvItem.mask |= LVIF_STATE;
		lvItem.state = nState;
	}
	if (nImageIndex != -1)
	{
		lvItem.mask |= LVIF_IMAGE;
		lvItem.iImage = nImageIndex;
	}
	if (nParam != -1)
	{
		lvItem.mask |= LVIF_PARAM;
		lvItem.lParam = nParam;
	}
	if (nSubItem == 0)
		return m_ctrlFileList.InsertItem(&lvItem);
	else
		return m_ctrlFileList.SetItem(&lvItem);
}

void CPDFMerge::OnDblclkListFiles(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnView();	
	*pResult = 0;
}
void CPDFMerge::OnRegister() 
{
	ShellExecute(NULL,"open","http://www.verypdf.com/pdfpg",NULL,NULL,SW_SHOW);
}
